<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'user';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);
$smarty->assign('submenu', 'favorites');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 会员模块
include_once (ROOT_PATH . 'include/user.class.php');
$dou_user = new DouUser();

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center('favorites', 'admin'));

/**
 * +----------------------------------------------------------
 * VIP开通记录
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['favorites']);
    
    // 生成筛选条件
    $field = array('item_id', 'user_id');
    $key = array();
    foreach ($field as $value) {
        $v['value'] = $value;
        $v['name'] = $_LANG['favorites_' . $value];
        $v['cur'] = ($value == $_REQUEST['key']) ? true : false;
        $key[] = $v;
    }

    // 筛选关键词
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    if ($keyword) {
        if ($_REQUEST['key'] == 'item_id')
            $keyword = $dou->get_value('product', 'id', "name LIKE '%$keyword%'");
     
        if ($_REQUEST['key'] == 'user_id')
            $keyword = $dou->get_value('user', 'user_id', "email LIKE '%$keyword%' OR telphone LIKE '%$keyword%'");
        
        $where = " WHERE $_REQUEST[key] LIKE '%$keyword%'";
    }
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('favorites') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'favorites.php' . ($_REQUEST['key'] ? '?key=' . $_REQUEST['key'] : '') . ($keyword ? '&keyword=' . $keyword : '');
    $limit = $dou->pager($sql, 15, $page, $page_url);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $field = $row['module'] == 'product' ? 'name' : 'title'; 
        $item = $dou->get_row($row['module'], "$field, id, price, image", "id = '$row[item_id]'");
        
        $favorites_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "module" => $_LANG[$row['module']],
                "item_id" => $row['item_id'],
                "name" => $item['name'] ? $item['name'] : $item['title'],
                "deducted_price" => $row['price'] - $item['price'] > 0 ? $dou->price_format($row['price'] - $item['price']) : '',
                "price" => $dou->price_format($row['price']),
                "image" => $row['module'] == 'product' ? $dou->dou_file($item['image'], true) : $dou->dou_file($item['image']),
                "url" => $dou->rewrite_url($row['module'], $row['item_id']),
                "del_url" => $dou->param($_URL['del'] . '&id=' . $row['id']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('key', $key);
    $smarty->assign('keyword', $keyword);
    $smarty->assign('favorites_list', $favorites_list);
    
    $smarty->display('favorites.htm');
}

/**
 * +----------------------------------------------------------
 * 记录删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'favorites.php');
 
    // 获取购买信息
    $favorites = $dou->get_row('favorites', '*', "id = '$id'");
    $user = $dou->user_basic($favorites['user_id']);
    $item = $dou->get_row($favorites['module'], "*", "id = '$favorites[item_id]'");
    $name = $item['name'] ? $item['name'] : $item['title'];
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['favorites_del'] . ': ' . $user['username'] . $_LANG['favorites'] . '-' . $name);
        $dou->delete('favorites', "id = '$id'", 'favorites.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $user['username'] . $_LANG['favorites'] . '-' . $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'favorites.php?'. '&page=' . $_SESSION[DOU_ID]['page'], '', '30', "favorites.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            $dou->del_all('favorites', $_POST['checkbox'], 'id');
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['select_empty']);
    }
}

?>