<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'add|user|del';
$subbox = array(
        "module" => 'favorites',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'favorites';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 验证是否登录
if (!is_array($_GLOBAL_USER))
    $dou->dou_header($_URL['login']);

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'favorites', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center($_CUR));
$smarty->assign('if_connect_plugin', $dou->value_exist('plugin', 'plugin_group', 'connect'));

/**
 * +----------------------------------------------------------
 * 收藏夹申请页
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $dou->dou_header(HOME_URL);
}

/**
 * +----------------------------------------------------------
 * 添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $module = $check->is_extend_id($_POST['module']) ? $_POST['module'] : 'product';
    $item_id = $check->is_number($_POST['item_id']) ? $_POST['item_id'] : '';
    
    $value_exist = $dou->value_exist('favorites', 'item_id', $item_id, "module = '$module' AND user_id = '$_GLOBAL_USER[user_id]'");
    
    if (!$value_exist) {
        $price = $dou->get_value($module, 'price', "id = '$item_id'");
        $add_time = time();

        $dou->query("INSERT INTO " . $dou->table('favorites') . " (id, user_id, module, item_id, price, add_time)" . " VALUES (NULL, '$_GLOBAL_USER[user_id]', '$module', '$item_id', '$price', '$add_time')");
    } 

    $data['msg'] = $_LANG['favorites_add_success'];
    $data['text'] = $_LANG['favorites_ed'];

    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $dou->delete('favorites', "id = '$id' AND user_id = '$_GLOBAL_USER[user_id]'");
    $dou->dou_header($dou->param($_URL['sub']['user'] . '&page=' . $_SESSION[DOU_ID]['page']));
}

/**
 * +----------------------------------------------------------
 * 会员中心
 * +----------------------------------------------------------
 */
elseif ($rec == 'user') {
    // 需要登录且没有登录的情况
    if (!is_array($_GLOBAL_USER))
        $dou->dou_header($_URL['login']);

    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('favorites') . " WHERE user_id = '$_GLOBAL_USER[user_id]' ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 16, $page, $_URL['sub']['user']);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $field = $row['module'] == 'product' ? 'name' : 'title'; 
        $item = $dou->get_row($row['module'], "$field, id, price, image", "id = '$row[item_id]'");
        
        $favorites_list[] = array (
                "id" => $row['id'],
                "module" => $_LANG[$row['module']],
                "item_id" => $row['item_id'],
                "name" => $item['name'] ? $item['name'] : $item['title'],
                "deducted_price" => $row['price'] - $item['price'] > 0 ? $dou->price_format($row['price'] - $item['price']) : '',
                "price" => $dou->price_format($row['price']),
                "image" => $row['module'] == 'product' ? $dou->dou_file($item['image'], true) : $dou->dou_file($item['image']),
                "url" => $dou->rewrite_url($row['module'], $row['item_id']),
                "del_url" => $dou->param($_URL['del'] . '&id=' . $row['id']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'favorites'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'favorites'));
    $smarty->assign('head', $_LANG['favorites']);
    $smarty->assign('favorites_list', $favorites_list);

    $smarty->display('favorites.dwt');
}

?>