<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'success|user';
$subbox = array(
        "module" => 'favorites',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'favorites';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/order.class.php');
$dou_order = new Order();

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

if (!$_OPEN['user'])
    $dou->dou_msg($_LANG['dh_no_install_user'], ROOT_URL);

// 验证是否登录
if (!is_array($_GLOBAL_USER)) {
    if ($rec == 'success') {
        $data['nologin'] = true;
        echo json_encode($data);
        exit;
    } else {
        $dou->dou_header($_URL['login']);
    }
}

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'favorites', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center($_CUR));
$smarty->assign('if_connect_plugin', $dou->value_exist('plugin', 'plugin_group', 'connect'));

/**
 * +----------------------------------------------------------
 * 收藏夹申请页
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $sql = "SELECT * FROM " . $dou->table('favorites_package') . " ORDER BY sort ASC, id DESC";
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $package_list[] = array (
                "id" => $row['id'],
                "name" => $row['name'],
                "day" => $row['day'],
                "price" => $row['price'] > 0 ? $dou->price_format($row['price']) : '',
                "content" => explode("\r\n", $row['content']),
                "image" => $dou->dou_file($row['image'])
        );
    }
    
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->set_token('favorites'));

    // 赋值给模板-meta和title信息
    $smarty->assign('page_title', $dou->page_title('favorites'));
    
    // 赋值给模板-数据
    $smarty->assign('action', $action);
    $smarty->assign('ur_here', $dou->ur_here('favorites'));
    $smarty->assign('head', $_LANG['favorites']);
    $smarty->assign('package_list', $package_list);
    $smarty->assign('content_field', favorites_package_content());
    
    $smarty->display('favorites.dwt');
}

/**
 * +----------------------------------------------------------
 * 完成订单操作，提交到数据库
 * +----------------------------------------------------------
 */
elseif ($rec == 'success') {
    // 获取ID
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format[$key] = '<p class="cue">' . $value . '</p>';
        }
        $dou->dou_msg($wrong_format, $_URL['edit']);
    }
 
    // 验证是否登录
    if (!is_array($_GLOBAL_USER))
        $dou->dou_header($_URL['login']);
 
    // VIP套餐
    $package = $dou->get_row('favorites_package', 'id, name, day, price, image', "id = '$id'");
 
    // 会员信息
    $user = $dou->get_row('user', 'telphone, contact, phone, address, postcode', "user_id = '$_GLOBAL_USER[user_id]'");
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'favorites');
    
    // 订单信息插入
    $module = 'favorites';
    $item_amount = $package['price']; // 商品金额
    $point = $package['price']; // 购买获得积分
    $item_id = $package['id']; // 没有项目ID，默认为1
    $item_name = $_LANG[$module] . '-' . $package['name']; // 项目名称
    $order_amount = $item_amount; // 订单总金额
    $order_sn = $dou_order->create_order_sn();
    $add_time = $time = time();
    $phone = $user['telphone'] ? $user['telphone'] : $user['phone'];
    $item_link_status = 1; // 付款后VIP套餐购买状态标记为1
    
    // html安全过滤器
    $_POST = $firewall->dou_foreground($_POST);
    
    // 订单信息插入
    $sql = "INSERT INTO " . $dou->table('order') . " (order_id, order_sn, user_id, module, item_id, item_name, item_link_status, phone, contact, address, postcode, item_amount, order_amount, add_time)" . " VALUES (NULL, '$order_sn', '$_GLOBAL_USER[user_id]', '$module', '$item_id', '$item_name', '$item_link_status', '$phone', '$user[contact]', '$user[address]', '$user[postcode]', '$item_amount', '$order_amount', '$add_time')";
    
    // 如果订单生成成功
    if ($dou->query($sql)) {
        // 订单商品插入
        $order_id = $dou->insert_id();
        $dou->query("INSERT INTO " . $dou->table('order_item') . " (id, user_id, order_id, module, item_id, name, price, point, item_number)" . " VALUES (NULL, '$_GLOBAL_USER[user_id]', '$order_id', '$module', '$item_id', '$item_name', '$item_amount', '$point', '1')");
        
        // 服务卡信息
        $favorites_log = $dou->get_row('favorites', 'start_time, end_time', "user_id = '$_GLOBAL_USER[user_id]' ORDER BY id DESC");
        
        $start_time = $favorites_log['end_time'] && $favorites_log['end_time'] > $time ? $favorites_log['end_time'] : $time;
        $end_time = strtotime('+' . $package['day'] . ' day', $start_time);
        $ip = $dou->get_ip();
        
        // VIP购买记录
        $dou->query("INSERT INTO " . $dou->table('favorites') . " (id, user_id, id, price, start_time, end_time, order_sn, image, ip, add_time)" . " VALUES (NULL, '$_GLOBAL_USER[user_id]', '$package[id]', '$package[price]', '$start_time', '$end_time', '$order_sn', '$package[image]', '$ip', '$add_time')");
    }
    
    // 显示订单信息
    $order['order_sn'] = $order_sn;
    $order['order_amount'] = $order_amount;
    $order['order_amount_format'] = $dou->price_format($order_amount);

    // 如果设置了支付方式，则跳转到收银台
    if ($dou->value_exist('plugin', 'plugin_group', 'payment')) {
        $cashier_url = $dou->param($dou->rewrite_url('order', 'cashier') . '&order_sn=' . $order['order_sn']);
        $dou->dou_header($cashier_url);
    }
    
    $smarty->assign('page_title', $dou->page_title('order_success'));
    $smarty->assign('order', $order);
    
    $smarty->display('order.dwt');
} 

/**
 * +----------------------------------------------------------
 * 会员中心
 * +----------------------------------------------------------
 */
elseif ($rec == 'user') {
    // 需要登录且没有登录的情况
    if (!is_array($_GLOBAL_USER))
        $dou->dou_header($_URL['login']);

    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('favorites') . " WHERE user_id = '$_GLOBAL_USER[user_id]' ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $_URL['sub']['user']);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $favorites_log[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "package" => $dou->get_row('favorites_package', 'name, day, price', "id = '$row[id]'"),
                "price" => $dou->price_format($row['price']),
                "start_time" => date("Y-m-d", $row['start_time']),
                "end_time" => date("Y-m-d", $row['end_time']),
                "order_sn" => $row['order_sn'],
                "order_link" => $dou->param($_URL['order'] . '&order_sn=' . $row['order_sn']),
                "ip" => $row['ip'],
                "status" => $dou->data_lang_format('favorites_status_', $row['status']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }

    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'favorites_log'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'favorites_log'));
    $smarty->assign('head', $_LANG['favorites_log']);
    $smarty->assign('favorites_log', $favorites_log);

    $smarty->display('favorites_user.dwt');
}

/**
 * +----------------------------------------------------------
 * 收藏夹套餐简介字段格式化
 * +----------------------------------------------------------
 */
function favorites_package_content() {
    return explode(',', $GLOBALS['_PARAM']['favorites_package_content']);
}

?>