// pages/favorites/user.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    favorites_list: {},
    page: 1, // 初始页默认值为1
    startX: 0, // 开始X坐标
    startY: 0, // 开始Y坐标
    nomore: false
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
    
    wx.setNavigationBarTitle({
      title: app.title.favorites_user
    })
   
    // 设置转发标题缓存
    wx.setStorageSync('shareTitle', app.title.favorites_user)
    
    // 显示转发按钮
    dou.showShareMenu()
    
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    that.loadData()
  },

  // 获取数据
  loadData: function(concat = false, page = '') {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'favorites.php?rec=user',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        page: page ? page : that.data.page, // 从数据里获取当前页数
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (concat) {
          var dataBox = that.data.favorites_list; // 从data获取当前datalist数组
          var dataNew = res.data.favorites_list; // 从此次请求返回的数据中获取新数组
          
          if (dataNew) {
            dataBox = dataBox.concat(dataNew); // 合并数组
          } else {
            that.setData({
              nomore: true
            })
          }
        } else {
          dataBox = res.data.favorites_list;
        }
        
        that.setData({
          favorites_list: dataBox,
          loadpage: false
        })
      }
    })
  },
 
  onReachBottom: function () { // 触底开始下一页
    var that = this;
    
    if (!that.data.nomore) {
      var page = that.data.page + 1; // 获取当前页数并+1
    
      that.setData({
        page: page, // 更新当前页数
        loadpage: true,//加载动画的显示
      })

      setTimeout (
        function() { //注意function这里不能缺少
          that.loadData(true); // 重新调用请求获取下一页数据
        },1000
      )
    }
  },

  itemDel: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action')
    console.log('删除')
    wx.request({
      url: app.mp_url + 'favorites.php?rec=del',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        'id': e.currentTarget.dataset.id
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        that.loadData()
      }
    })
  },
 
  // 手指触摸动作开始
  touchStart: function(e){
      var that = this;
   
      // 记录手指触摸开始坐标
      that.setData({
          startX: e.changedTouches[0].clientX,  // 开始X坐标
          startY: e.changedTouches[0].clientY,  // 开始Y坐标
      })
  },

  // 手指触摸后移动
  touchMove: function(e){
      var that = this;
      
      var index = e.currentTarget.dataset.index; // 当前下标
      var favorites_list = that.data.favorites_list;
   
      var startX = that.data.startX; // 开始X坐标
      var startY = that.data.startY; // 开始Y坐标
      var touchMoveX = e.changedTouches[0].clientX; // 滑动变化坐标
      var touchMoveY = e.changedTouches[0].clientY; // 滑动变化坐标
      var moveWidth = startX - touchMoveX;
      
      // 获取滑动角度
      var angle = that.angle({ X: startX, Y: startY }, { X: touchMoveX, Y: touchMoveY });
      
      if (Math.abs(angle) > 45) return;
   
      if (favorites_list[index].touch_move_start == 80) {
          if (moveWidth > 0) {
              return;
          } else {
              var touchMove = favorites_list[index].touch_move_start + moveWidth;
          }
      } else {
          if (moveWidth > 80)
              var moveWidth = 80;

          if (moveWidth < 0)
              var moveWidth = 0;
          
          var touchMove = moveWidth;
      }
   
      favorites_list[index].touch_move = touchMove;
   
      that.setData({
        favorites_list: favorites_list
      })
  },

  // 手指触摸后停止
  touchEnd: function(e){
      var that = this;
      
      var index = e.currentTarget.dataset.index; // 当前下标
      var favorites_list = that.data.favorites_list;
      
      var startX = that.data.startX; // 开始X坐标
      var startY = that.data.startY; // 开始Y坐标
      var touchMoveX = e.changedTouches[0].clientX; // 滑动变化坐标
      var touchMoveY = e.changedTouches[0].clientY; // 滑动变化坐标
      var moveWidth = startX - touchMoveX; // 滑动距离
      
      // 获取滑动角度
      var angle = that.angle({ X: startX, Y: startY }, { X: touchMoveX, Y: touchMoveY });
    
      if (Math.abs(angle) > 45) return;
      
      if (moveWidth >= 0) {
          // 划入操作
          if (moveWidth > 20) {
              var moveWidth = 80;
          } else {
              var moveWidth = 0;
          }
      } else {
          if (moveWidth < -20) {
              var moveWidth = 0;
          } else {
              var moveWidth = 80;
          }
              
      }
   
      favorites_list[index].touch_move = moveWidth;
      favorites_list[index].touch_move_start = moveWidth;
   
      that.setData({
        favorites_list: favorites_list
      })
      
      //console.log(touchMoveX)
  },

  // 计算滑动角度
  angle: function (start, end) {
      let that = this,
          _X = end.X - start.X,
          _Y = end.Y - start.Y;
      
      // 返回角度 /Math.atan()返回数字的反正切值
      return 360 * Math.atan(_Y / _X) / (2 * Math.PI);
  },

  itemDel: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action')
    
    wx.request({
      url: app.mp_url + 'favorites.php?rec=del',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        'id': e.currentTarget.dataset.id
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        that.loadData()
      }
    })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})